package fit;

// Copyright (c) 2002 Cunningham & Cunningham, Inc.
// Released under the terms of the GNU General Public License version 2 or later.

// Warning: not (yet) a general number usable in all calculations.

public class ScientificDouble extends Number implements Comparable {
    double value;
    double precision;

    public static ScientificDouble valueOf(String s) {
        ScientificDouble result = new ScientificDouble();
        result.value = Double.parseDouble(s);
        result.precision = precision(s);
        return result;
    }

    public static double precision (String s) {
        double precision = 5;
        for (int i=0; i<s.length(); i++) {
            char ch = s.charAt(i);
            if (Character.isDigit(ch)) {
                precision /= 10;
            } else if (Character.toLowerCase(ch) == 'e') {
                break;
            }
        }
        return precision;
    }

    public boolean equals(Object obj) {
        return compareTo(obj) == 0;
    }

    public int compareTo(Object obj) {
        double other = ((Number)obj).doubleValue();
        double diff = (value-other)/value;
        // System.out.println(value+" "+precision+" "+diff);
        if (diff < -precision) return -1;
        if (diff > precision) return 1;
        if (Double.isNaN(value) && Double.isNaN(other)) return 0;
        if (Double.isNaN(value)) return 1;
        if (Double.isNaN(other)) return -1;
        return 0;
    }

    public String toString() {
        return Double.toString(value);
    }

    public double doubleValue() {
        return value;
    }

    public float floatValue() {
        return (float)value;
    }

    public long longValue() {
        return (long)value;
    }

    public int intValue() {
        return (int)value;
    }
}
